Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -6899,31 +6805,28 @@
 !
 !> Moving-centre method minimises numerical diffusion. 
-!------------------------------------------------------------------------------!      
+!------------------------------------------------------------------------------!
  SUBROUTINE distr_update( paero )
-    
+
     IMPLICIT NONE
 
-!-- Input and output variables
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b) !< Aerosols particle 
-                                    !< size distribution and properties
-!-- Local variables
-    INTEGER(iwp) ::  b !< loop index
-    INTEGER(iwp) ::  mm !< loop index
-    INTEGER(iwp) ::  counti
-    LOGICAL  ::  within_bins !< logical (particle belongs to the bin?)    
-    REAL(wp) ::  znfrac !< number fraction to be moved to the larger bin
-    REAL(wp) ::  zvfrac !< volume fraction to be moved to the larger bin
-    REAL(wp) ::  zVexc  !< Volume in the grown bin which exceeds the bin 
-                        !< upper limit    
-    REAL(wp) ::  zVihi  !< particle volume at the high end of the bin    
-    REAL(wp) ::  zVilo  !< particle volume at the low end of the bin     
-    REAL(wp) ::  zvpart !< particle volume (m3)    
-    REAL(wp) ::  zVrat  !< volume ratio of a size bin
-    
-    zvpart = 0.0_wp
-    zvfrac = 0.0_wp
-
+    INTEGER(iwp) ::  ib      !< loop index
+    INTEGER(iwp) ::  mm      !< loop index
+    INTEGER(iwp) ::  counti  !< number of while loops
+
+    LOGICAL  ::  within_bins !< logical (particle belongs to the bin?)
+
+    REAL(wp) ::  znfrac  !< number fraction to be moved to the larger bin
+    REAL(wp) ::  zvfrac  !< volume fraction to be moved to the larger bin
+    REAL(wp) ::  zVexc   !< Volume in the grown bin which exceeds the bin upper limit
+    REAL(wp) ::  zVihi   !< particle volume at the high end of the bin
+    REAL(wp) ::  zVilo   !< particle volume at the low end of the bin
+    REAL(wp) ::  zvpart  !< particle volume (m3)
+    REAL(wp) ::  zVrat   !< volume ratio of a size bin
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero !< aerosol properties
+
+    zvpart      = 0.0_wp
+    zvfrac      = 0.0_wp
     within_bins = .FALSE.
-    
 !
 !-- Check if the volume of the bin is within bin limits after update
@@ -6931,94 +6834,96 @@
     DO  WHILE ( .NOT. within_bins )
        within_bins = .TRUE.
-
-       DO  b = fn2b-1, in1a, -1
+!
+!--    Loop from larger to smaller size bins
+       DO  ib = end_subrange_2b-1, start_subrange_1a, -1
           mm = 0
-          IF ( paero(b)%numc > nclim )  THEN
-
+          IF ( paero(ib)%numc > nclim )  THEN
              zvpart = 0.0_wp
              zvfrac = 0.0_wp
 
-             IF ( b == fn2a )  CYCLE 
+             IF ( ib == end_subrange_2a )  CYCLE
 !
 !--          Dry volume
-             zvpart = SUM( paero(b)%volc(1:7) ) / paero(b)%numc 
+             zvpart = SUM( paero(ib)%volc(1:7) ) / paero(ib)%numc
 !
 !--          Smallest bin cannot decrease
-             IF ( paero(b)%vlolim > zvpart  .AND.  b == in1a ) CYCLE
+             IF ( paero(ib)%vlolim > zvpart  .AND.  ib == start_subrange_1a ) CYCLE
 !
 !--          Decreasing bins
-             IF ( paero(b)%vlolim > zvpart )  THEN
-                mm = b - 1
-                IF ( b == in2b )  mm = fn1a    ! 2b goes to 1a
-               
-                paero(mm)%numc = paero(mm)%numc + paero(b)%numc
-                paero(b)%numc = 0.0_wp
-                paero(mm)%volc(:) = paero(mm)%volc(:) + paero(b)%volc(:) 
-                paero(b)%volc(:) = 0.0_wp
+             IF ( paero(ib)%vlolim > zvpart )  THEN
+                mm = ib - 1
+                IF ( ib == start_subrange_2b )  mm = end_subrange_1a    ! 2b goes to 1a
+
+                paero(mm)%numc = paero(mm)%numc + paero(ib)%numc
+                paero(ib)%numc = 0.0_wp
+                paero(mm)%volc(:) = paero(mm)%volc(:) + paero(ib)%volc(:)
+                paero(ib)%volc(:) = 0.0_wp
                 CYCLE
              ENDIF
 !
-!--          If size bin has not grown, cycle
-!--          Changed by Mona: compare to the arithmetic mean volume, as done 
-!--          originally. Now particle volume is derived from the geometric mean 
-!--          diameter, not arithmetic (see SUBROUTINE set_sizebins).
-             IF ( zvpart <= api6 * ( ( aero(b)%vhilim + aero(b)%vlolim ) /     &
-                  ( 2.0_wp * api6 ) ) )  CYCLE  
-             IF ( ABS( zvpart - api6 * paero(b)%dmid ** 3.0_wp ) < &
-                  1.0E-35_wp )  CYCLE  ! Mona: to avoid precision problems
-!                   
+!--          If size bin has not grown, cycle.
+!--          Changed by Mona: compare to the arithmetic mean volume, as done originally. Now 
+!--          particle volume is derived from the geometric mean diameter, not arithmetic (see 
+!--          SUBROUTINE set_sizebins).
+             IF ( zvpart <= api6 * ( ( aero(ib)%vhilim + aero(ib)%vlolim ) / ( 2.0_wp * api6 ) ) ) &
+             CYCLE
+!
+!--          Avoid precision problems
+             IF ( ABS( zvpart - api6 * paero(ib)%dmid**3 ) < 1.0E-35_wp )  CYCLE
+!
 !--          Volume ratio of the size bin
-             zVrat = paero(b)%vhilim / paero(b)%vlolim
+             zVrat = paero(ib)%vhilim / paero(ib)%vlolim
+!
 !--          Particle volume at the low end of the bin
              zVilo = 2.0_wp * zvpart / ( 1.0_wp + zVrat )
+!
 !--          Particle volume at the high end of the bin
              zVihi = zVrat * zVilo
+!
 !--          Volume in the grown bin which exceeds the bin upper limit
-             zVexc = 0.5_wp * ( zVihi + paero(b)%vhilim )
+             zVexc = 0.5_wp * ( zVihi + paero(ib)%vhilim )
+!
 !--          Number fraction to be moved to the larger bin
-             znfrac = MIN( 1.0_wp, ( zVihi - paero(b)%vhilim) /                &
-                           ( zVihi - zVilo ) )
+             znfrac = MIN( 1.0_wp, ( zVihi - paero(ib)%vhilim) / ( zVihi - zVilo ) )
+!
 !--          Volume fraction to be moved to the larger bin
              zvfrac = MIN( 0.99_wp, znfrac * zVexc / zvpart )
              IF ( zvfrac < 0.0_wp )  THEN
                 message_string = 'Error: zvfrac < 0'
-                CALL message( 'salsa_mod: distr_update', 'SA0050',             &
-                              1, 2, 0, 6, 0 )
+                CALL message( 'salsa_mod: distr_update', 'PA0624', 1, 2, 0, 6, 0 )
              ENDIF
 !
 !--          Update bin
-             mm = b + 1
+             mm = ib + 1
+!
 !--          Volume (cm3/cm3)
-             paero(mm)%volc(:) = paero(mm)%volc(:) + znfrac * paero(b)%numc *  &
-                                 zVexc * paero(b)%volc(:) /                    &
-                                 SUM( paero(b)%volc(1:7) )
-             paero(b)%volc(:) = paero(b)%volc(:) - znfrac * paero(b)%numc *    &
-                                 zVexc * paero(b)%volc(:) /                    &
-                                 SUM( paero(b)%volc(1:7) )
+             paero(mm)%volc(:) = paero(mm)%volc(:) + znfrac * paero(ib)%numc * zVexc *             &
+                                 paero(ib)%volc(:) / SUM( paero(ib)%volc(:) )
+             paero(ib)%volc(:) = paero(ib)%volc(:) - znfrac * paero(ib)%numc * zVexc *             &
+                                 paero(ib)%volc(:) / SUM( paero(ib)%volc(:) )
 
 !--          Number concentration (#/m3)
-             paero(mm)%numc = paero(mm)%numc + znfrac * paero(b)%numc
-             paero(b)%numc = paero(b)%numc * ( 1.0_wp - znfrac )
+             paero(mm)%numc = paero(mm)%numc + znfrac * paero(ib)%numc
+             paero(ib)%numc = paero(ib)%numc * ( 1.0_wp - znfrac )
 
           ENDIF     ! nclim
-          
-          IF ( paero(b)%numc > nclim )   THEN
-             zvpart = SUM( paero(b)%volc(1:7) ) / paero(b)%numc 
-             within_bins = ( paero(b)%vlolim < zvpart  .AND.                  &
-                             zvpart < paero(b)%vhilim )
+
+          IF ( paero(ib)%numc > nclim )   THEN
+             zvpart = SUM( paero(ib)%volc(:) ) / paero(ib)%numc
+             within_bins = ( paero(ib)%vlolim < zvpart  .AND. zvpart < paero(ib)%vhilim )
           ENDIF
 
-       ENDDO ! - b
+       ENDDO ! - ib
 
        counti = counti + 1
        IF ( counti > 100 )  THEN
           message_string = 'Error: Aerosol bin update not converged'
-          CALL message( 'salsa_mod: distr_update', 'SA0051', 1, 2, 0, 6, 0 )
-       ENDIF 
+          CALL message( 'salsa_mod: distr_update', 'PA0625', 1, 2, 0, 6, 0 )
+       ENDIF
 
     ENDDO ! - within bins
-    
+
  END SUBROUTINE distr_update
-      
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -7030,29 +6935,29 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_diagnostics( i, j )
- 
+
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
 
     IMPLICIT NONE
-    
+
+    INTEGER(iwp) ::  ib   !<
+    INTEGER(iwp) ::  ic   !<
+    INTEGER(iwp) ::  icc  !<
+    INTEGER(iwp) ::  ig   !<
+    INTEGER(iwp) ::  k    !<
+
     INTEGER(iwp), INTENT(in) ::  i  !<
-    INTEGER(iwp), INTENT(in) ::  j  !<    
-
-    INTEGER(iwp) ::  b !<
-    INTEGER(iwp) ::  c  !< 
-    INTEGER(iwp) ::  gt  !< 
-    INTEGER(iwp) ::  k  !<
-    INTEGER(iwp) ::  nc !<
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  flag         !< flag to mask topography
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  flag_zddry   !< flag to mask zddry
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_adn       !< air density (kg/m3)    
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_p         !< pressure
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_t         !< temperature (K)    
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  mcsum        !< sum of mass concentration
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  ppm_to_nconc !< Conversion factor 
-                                                    !< from ppm to #/m3 
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  zddry  !<
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  zvol   !<
-    
+    INTEGER(iwp), INTENT(in) ::  j  !<
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  flag          !< flag to mask topography
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  flag_zddry    !< flag to mask zddry
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_adn        !< air density (kg/m3)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_p          !< pressure
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_t          !< temperature (K)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  mcsum         !< sum of mass concentration
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  ppm_to_nconc  !< Conversion factor: ppm to #/m3
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  zddry         !< particle dry diameter
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  zvol          !< particle volume
+
     flag_zddry   = 0.0_wp
     in_adn       = 0.0_wp
@@ -7062,10 +6967,9 @@
     zddry        = 0.0_wp
     zvol         = 0.0_wp
-    
+
     CALL cpu_log( log_point_s(94), 'salsa diagnostics ', 'start' )
-
-!             
+!
 !-- Calculate thermodynamic quantities needed in SALSA
-    CALL salsa_thrm_ij( i, j, p_ij=in_p, temp_ij=in_t, adn_ij=in_adn )       
+    CALL salsa_thrm_ij( i, j, p_ij=in_p, temp_ij=in_t, adn_ij=in_adn )
 !
 !-- Calculate conversion factors for gas concentrations
